Index: /main/trunk/greenstone3/web/interfaces/oran/transform/layouts/header.xsl
===================================================================
--- /main/trunk/greenstone3/web/interfaces/oran/transform/layouts/header.xsl	(revision 24136)
+++ /main/trunk/greenstone3/web/interfaces/oran/transform/layouts/header.xsl	(revision 24137)
@@ -26,4 +26,7 @@
 		<link rel="stylesheet" href="interfaces/{$interface_name}/style/core.css" type="text/css"/>
 		<link rel="shortcut icon" href="favicon.ico"/> 
+        <script type="text/javascript" src="interfaces/oran/js/jquery-1.4.2.js"><xsl:text> </xsl:text></script>
+        <script type="text/javascript" src="interfaces/oran/js/jquery-ui-1.8rc1/ui/jquery-ui.js"><xsl:text> </xsl:text></script>
+        <script type="text/javascript" src="interfaces/oran/js/jquery.selectboxes.js"><xsl:text> </xsl:text></script>
 	</xsl:template>
 		
@@ -114,7 +117,7 @@
 				<!-- home -->
 				<li>
-					<a href="{$library_name}?a=p&amp;amp;sa=about&amp;amp;c={$collNameChecked}">
+					<a href="{$library_name}?a=p&amp;amp;sa=home">
 						<xsl:attribute name="title"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'home_tip')"/></xsl:attribute>
-						<xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'about_b')"/>
+						<xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'home_b')"/>
 					</a>
 				</li>
@@ -132,29 +135,29 @@
 					<xsl:choose>
 						<xsl:when test="string-length($pageTitleVar) &lt; 20">
-							font-size: 1.5em; line-height: 1.5em;
+							font-size: 24px; line-height: 26px;
 						</xsl:when>
 						<xsl:when test="string-length($pageTitleVar) &lt; 30">
-							font-size: 1.4em; line-height: 1.4em;
+							font-size: 22px; line-height: 24px;
 						</xsl:when>
 						<xsl:when test="string-length($pageTitleVar) &lt; 40">
-							font-size: 1.3em; line-height: 1.3em;
+							font-size: 20px; line-height: 22px;
 						</xsl:when>
 						<xsl:when test="string-length($pageTitleVar) &lt; 50">
-							font-size: 1.2em; line-height: 1.2em;
+							font-size: 18px; line-height: 20px;
 						</xsl:when>
 						<xsl:when test="string-length($pageTitleVar) &lt; 60">
-							font-size: 1.1em; line-height: 1.2em;
+							font-size: 16px; line-height: 18px;
 						</xsl:when>
 						<xsl:when test="string-length($pageTitleVar) &lt; 70">
-							font-size: 1em; line-height: 1.1em;
+							font-size: 15px; line-height: 17px;
 						</xsl:when>
 						<xsl:when test="string-length($pageTitleVar) &lt; 80">
-							font-size: 0.9em; line-height: 1em;
+							font-size: 14px; line-height: 16px;
 						</xsl:when>
 						<xsl:when test="string-length($pageTitleVar) &lt; 90">
-							font-size: 0.8em; line-height: 0.9em;
+							font-size: 13px; line-height: 15px;
 						</xsl:when>
 						<xsl:otherwise>
-							font-size: 0.7em; line-height: 0.9em;
+							font-size: 12px; line-height: 14px;
 						</xsl:otherwise>
 					</xsl:choose>
@@ -179,29 +182,4 @@
 					<input type="hidden" name="c" value="{$collNameChecked}"/>
 					<input type="hidden" name="startPage" value="1"/>
-					<xsl:choose>
-						<xsl:when test="/page/pageRequest/paramList/param[@name = 's1.maxDocs']">
-							<input type="hidden" name="s1.maxDocs">
-								<xsl:attribute name="value">
-									<xsl:value-of select="/page/pageRequest/paramList/param[@name = 's1.maxDocs']/@value"/>
-								</xsl:attribute>
-							</input>
-						</xsl:when>
-						<xsl:otherwise>
-							<input type="hidden" name="s1.maxDocs" value="100"/>
-						</xsl:otherwise>
-					</xsl:choose>
-					<xsl:choose>
-						<xsl:when test="/page/pageRequest/paramList/param[@name = 's1.hitsPerPage']">
-							<input type="hidden" name="s1.hitsPerPage">
-								<xsl:attribute name="value">
-									<xsl:value-of select="/page/pageRequest/paramList/param[@name = 's1.hitsPerPage']/@value"/>
-								</xsl:attribute>
-							</input>
-						</xsl:when>
-						<xsl:otherwise>
-							<input type="hidden" name="s1.hitsPerPage" value="20"/>
-						</xsl:otherwise>
-					</xsl:choose>
-					
 					<!-- The query text box -->
 					<span class="querybox">
Index: /main/trunk/greenstone3/web/interfaces/oran/transform/layouts/main.xsl
===================================================================
--- /main/trunk/greenstone3/web/interfaces/oran/transform/layouts/main.xsl	(revision 24136)
+++ /main/trunk/greenstone3/web/interfaces/oran/transform/layouts/main.xsl	(revision 24137)
@@ -16,8 +16,8 @@
 
 	<xsl:include href="header.xsl"/>
-	<!--<xsl:include href="formatmanager.xsl"/>-->
+	<xsl:include href="formatmanager.xsl"/>
 	
-	<xsl:include href="xml-to-gui.xsl"/>
-	<xsl:include href="xml-to-gui-templates.xsl"/>
+	<!--<xsl:include href="xml-to-gui.xsl"/>-->
+	<!--<xsl:include href="xml-to-gui-templates.xsl"/>-->
 
 	<!-- put the URL or path of your site here site -->
@@ -53,7 +53,9 @@
 
 					</div>
-					
-					<!--<xsl:call-template name="formatmanagerpre"/>-->
 
+                    <xsl:if test="/page/pageRequest/paramList/param[(@name='formatedit') and (@value='1')]">
+    					<xsl:call-template name="formatmanagerpre"/>
+                    </xsl:if>
+    
 					<div id="gs_content">
 						<!--
Index: /main/trunk/greenstone3/web/interfaces/oran/transform/layouts/xml-to-gui.xsl
===================================================================
--- /main/trunk/greenstone3/web/interfaces/oran/transform/layouts/xml-to-gui.xsl	(revision 24136)
+++ /main/trunk/greenstone3/web/interfaces/oran/transform/layouts/xml-to-gui.xsl	(revision 24137)
@@ -72,5 +72,5 @@
         <xsl:choose>
             <xsl:when test="$exists='TRUE'">
-                <select>
+                <select name="meta_select" onChange="onSelectChange(this)">
                     <xsl:apply-templates select="$metadataSets" mode="meta-to-combo">
                         <xsl:with-param name="current" select="$current_mod"/>
@@ -193,5 +193,5 @@
         <div class="gsf_link css_gsf_link block" title="gsf:link">
         <xsl:variable name="link">
-                LINK<select>
+                LINK<select name="link_select" onChange="onSelectChange(this)">
                     <xsl:choose>
                         <xsl:when test="@type='document'">
@@ -309,5 +309,5 @@
         <div class="gsf_icon css_gsf_icon block leaf" title="gsf:icon">
             <xsl:variable name="icon">
-                ICON<select>
+                ICON<select name="icon_select" onChange="onSelectChange(this, this.value)">
                     <xsl:choose>
                         <xsl:when test="@type='document'">
@@ -354,8 +354,22 @@
         <xsl:param name="metadataSets"/>
         
-        <div class="block leaf gsf_text" title="gsf:text">
-                <xsl:variable name="rawtext"><xsl:value-of select="."/></xsl:variable>
-                <table class="header"><tbody><tr><td class="header"><input class="text" type="text" name="rawtextinput" size="10" value="{$rawtext}" onChange="onTextChange(this, this.value)"></input></td><td class="header"><a href="[myhref]" class="ui-icon ui-icon-closethick"/></td></tr></tbody></table>
-        </div>
+        <xsl:variable name="rawtext"><xsl:value-of select="."/></xsl:variable>
+
+        <xsl:if test="normalize-space($rawtext) != '' ">
+            <div class="block leaf gsf_text" title="gsf:text">
+                <table class="header">
+                    <tbody>
+                        <tr>
+                            <td class="header">
+                                <input class="text" type="text" name="rawtextinput" size="10" value="{$rawtext}" onChange="onTextChange(this, this.value)"></input>
+                            </td>
+                            <td class="header">
+                                <a href="[myhref]" class="ui-icon ui-icon-closethick"/>
+                            </td>
+                        </tr>
+                    </tbody>
+                </table>
+            </div>
+        </xsl:if>
     </xsl:template>
 