Index: /main/trunk/gli/help/ja/designingacollection.htm
===================================================================
--- /main/trunk/gli/help/ja/designingacollection.htm	(revision 24205)
+++ /main/trunk/gli/help/ja/designingacollection.htm	(revision 24206)
@@ -12,4 +12,6 @@
 
 
+<p>ãã¡ã€ã«ãã¡ã¿ããŒã¿ã«ãã£ãŠããŒã¯ã¢ããããããšãæ¬¡ã«ãšã³ããŠãŒã¶ãŒã«ã©ã®ããã«ãã­ã¥ã¡ã³ããã¢ã¯ã»ã¹ãããããæ±ºããããšã«ãªããŸããã©ã®çš®é¡ã®æ
+å ±ãæ€çŽ¢å¯èœã§ããããïŒãã­ã¥ã¡ã³ãã®ãã©ãŠãºã«ã©ã®ãããªæ¹æ³ãæäŸãããã§ããããïŒãããã®åé¡ã¯ã«ã¹ã¿ãã€ãºã§ããŸãïŒãã®ç¯ã§ã¯ã©ã®ããã«è¡ãããèšè¿°ããŸãã</p>
 
 
Index: /main/trunk/gli/help/ja/explodingfiles.htm
===================================================================
--- /main/trunk/gli/help/ja/explodingfiles.htm	(revision 24205)
+++ /main/trunk/gli/help/ja/explodingfiles.htm	(revision 24206)
@@ -12,5 +12,5 @@
 
 
-<p> MARC, OAI, CDS/ISIS, BibTex, Refer and ProCiteãªã©ã®ã¡ã¿ããŒã¿ã»ããŒã¿ããŒã¹ã®ãã¡ã€ã«ã®åœ¢åŒã¯ã°ãªãŒã³ã¹ããŒã³ã«ã€ã³ããŒãã§ããŸããããã®ã¡ã¿ããŒã¿ã¯ã©ã€ãã©ãªã¢ã³ã»ã€ã³ã¿ãŒf-ãšã¹ã§çŽæ¥è¡šç€ºãããç·šéããããšã¯ã§ããŸãããããããªãããã©ã€ãã©ãªã¢ã³ã»ã€ã³ã¿ãŒãã§ãŒã¹ã§ãã¡ã€ã«ããå±éããããã®åŸã§ã¡ã¿ããŒã¿ãè¡šç€ºãããç·šéã§ããŸãããã®ä»£ããã«ãäž»èŠãªå€éšã®ã¢ããªã±ãŒã·ã§ã³ãäœ¿çšããŠããå Žåã¯ããã¡ã€ã«ãäœæãããã­ã°ã©ã ã«æ»ã£ãŠãèšæ­£ãè¡ã£ãŠãããåã€ã³ããŒãããããšãã§ããŸãã</p>
+<p>MARC, OAI, CDS/ISIS, BibTex, Refer and ProCiteãªã©ã®ã¡ã¿ããŒã¿ã»ããŒã¿ããŒã¹ã®ãã¡ã€ã«ã®åœ¢åŒã¯ã°ãªãŒã³ã¹ããŒã³ã«ã€ã³ããŒãã§ããŸããããã®ã¡ã¿ããŒã¿ã¯ã©ã€ãã©ãªã¢ã³ã»ã€ã³ã¿ãŒf-ãšã¹ã§çŽæ¥è¡šç€ºãããç·šéããããšã¯ã§ããŸãããããããªãããã©ã€ãã©ãªã¢ã³ã»ã€ã³ã¿ãŒãã§ãŒã¹ã§ãã¡ã€ã«ããå±éããããã®åŸã§ã¡ã¿ããŒã¿ãè¡šç€ºãããç·šéã§ããŸãããã®ä»£ããã«ãäž»èŠãªå€éšã®ã¢ããªã±ãŒã·ã§ã³ãäœ¿çšããŠããå Žåã¯ããã¡ã€ã«ãäœæãããã­ã°ã©ã ã«æ»ã£ãŠãèšæ­£ãè¡ã£ãŠãããåã€ã³ããŒãããããšãã§ããŸãã</p>
 
 <p>ã¡ã¿ããŒã¿ã»ããŒã¿ããŒã¹ã»ãã¡ã€ã«ããå±éããããšãè¡šç€ºã»ç·šéå¯èœãªã¡ã¿ããŒã¿ãä»äžãããåå¥ã®ã¬ã³ãŒãã«åå²ãããŸãããã®æäœã¯å
Index: /main/trunk/gli/help/ja/help.xml
===================================================================
--- /main/trunk/gli/help/ja/help.xml	(revision 24205)
+++ /main/trunk/gli/help/ja/help.xml	(revision 24206)
@@ -34,5 +34,5 @@
 èŠãªæã«ã©ã®ããã«ãã«ããåŸããããåããã°ååã§ãã</Text>
 <Text id="14">ç¹å®ã®ã³ã³ãã­ã¹ãã®ããã«ããã¢ã€ã³ã³ãã¯ãªãã¯ããé©åãªãã«ãã»ãã­ã¹ããäœæãããçåç¬Šãã€ããé©åãªãã«ãã»ããã£ã³ã°ãããŒã¯ããã</Text>
-<!-- Missing translation: 15 -->
+<Text id="15">å¶åŸ¡ã«ã€ããŠã¯ãããŠã¹ããã®äžã«çœ®ããšã©ã®ããã«å¶åŸ¡ããããªãããæç€ºãããããŒã«ãããããè¡šç€ºãããŸãã</Text>
 <Text id="16">ã©ã€ãã©ãªã¢ã³ã»ã€ã³ã¿ãŒãã§ãŒã¹ãäœ¿çšããåã«ãæåã«ã°ãªãŒã³ã¹ãïŒã³ã®ãã­ã¥ã¡ã³ããŒã·ã§ã³ããèŠ§äžããã</Text>
 </Section>
@@ -200,5 +200,5 @@
 <Text id="exm-1">ã¡ã¿ããŒã¿ãã¡ã€ã«ããå±éããã</Text>
 </Title>
-<Text id="exm-2"> MARC, OAI, CDS/ISIS, BibTex, Refer and ProCiteãªã©ã®ã¡ã¿ããŒã¿ã»ããŒã¿ããŒã¹ã®ãã¡ã€ã«ã®åœ¢åŒã¯ã°ãªãŒã³ã¹ããŒã³ã«ã€ã³ããŒãã§ããŸããããã®ã¡ã¿ããŒã¿ã¯ã©ã€ãã©ãªã¢ã³ã»ã€ã³ã¿ãŒf-ãšã¹ã§çŽæ¥è¡šç€ºãããç·šéããããšã¯ã§ããŸãããããããªãããã©ã€ãã©ãªã¢ã³ã»ã€ã³ã¿ãŒãã§ãŒã¹ã§ãã¡ã€ã«ããå±éããããã®åŸã§ã¡ã¿ããŒã¿ãè¡šç€ºãããç·šéã§ããŸãããã®ä»£ããã«ãäž»èŠãªå€éšã®ã¢ããªã±ãŒã·ã§ã³ãäœ¿çšããŠããå Žåã¯ããã¡ã€ã«ãäœæãããã­ã°ã©ã ã«æ»ã£ãŠãèšæ­£ãè¡ã£ãŠãããåã€ã³ããŒãããããšãã§ããŸãã</Text>
+<Text id="exm-2">MARC, OAI, CDS/ISIS, BibTex, Refer and ProCiteãªã©ã®ã¡ã¿ããŒã¿ã»ããŒã¿ããŒã¹ã®ãã¡ã€ã«ã®åœ¢åŒã¯ã°ãªãŒã³ã¹ããŒã³ã«ã€ã³ããŒãã§ããŸããããã®ã¡ã¿ããŒã¿ã¯ã©ã€ãã©ãªã¢ã³ã»ã€ã³ã¿ãŒf-ãšã¹ã§çŽæ¥è¡šç€ºãããç·šéããããšã¯ã§ããŸãããããããªãããã©ã€ãã©ãªã¢ã³ã»ã€ã³ã¿ãŒãã§ãŒã¹ã§ãã¡ã€ã«ããå±éããããã®åŸã§ã¡ã¿ããŒã¿ãè¡šç€ºãããç·šéã§ããŸãããã®ä»£ããã«ãäž»èŠãªå€éšã®ã¢ããªã±ãŒã·ã§ã³ãäœ¿çšããŠããå Žåã¯ããã¡ã€ã«ãäœæãããã­ã°ã©ã ã«æ»ã£ãŠãèšæ­£ãè¡ã£ãŠãããåã€ã³ããŒãããããšãã§ããŸãã</Text>
 <Text id="exm-3">ã¡ã¿ããŒã¿ã»ããŒã¿ããŒã¹ã»ãã¡ã€ã«ããå±éããããšãè¡šç€ºã»ç·šéå¯èœãªã¡ã¿ããŒã¿ãä»äžãããåå¥ã®ã¬ã³ãŒãã«åå²ãããŸãããã®æäœã¯å
 ã«æ»ãããšãã§ããŸãããå
@@ -244,5 +244,5 @@
 ãªã©ïŒãç¥ããã<AutoText key="glidict::Metadata.Value"/>ã¯ã¡ã¿ããŒã¿ãšã¬ã¡ã³ãã®å€ïŒèè
 åãªã©ïŒãäžããŸãã</Text>
-<Text id="77"> <AutoText key="glidict::GUI.Enrich"/>ãã¥ãŒã®å·ŠåŽã«</Text>
+<Text id="77"><AutoText key="glidict::GUI.Enrich"/>ãã¥ãŒã®å·ŠåŽã«</Text>
 <Text id="78">ãã©ã«ããŒã¢ã€ã³ã³ãã¡ã¿ããŒã¿ãšã³ããªãŒã®èã«è¡šç€ºãããŸããå€ã¯èŠªïŒå
 ïŒãã©ã«ããŒããåãç¶ãããããšãç€ºããŠããŸããåãç¶ãããã¡ã¿ããŒã¿ã¯ç·šéã»åé€ã§ããŸãããæ·»ä»ã§ããã ãã§ãã</Text>
@@ -344,5 +344,6 @@
 <Text id="110">ã³ã¬ã¯ã·ã§ã³ãæ§æãã</Text>
 </Title>
-<!-- Missing translation: 111 -->
+<Text id="111">ãã¡ã€ã«ãã¡ã¿ããŒã¿ã«ãã£ãŠããŒã¯ã¢ããããããšãæ¬¡ã«ãšã³ããŠãŒã¶ãŒã«ã©ã®ããã«ãã­ã¥ã¡ã³ããã¢ã¯ã»ã¹ãããããæ±ºããããšã«ãªããŸããã©ã®çš®é¡ã®æ
+å ±ãæ€çŽ¢å¯èœã§ããããïŒãã­ã¥ã¡ã³ãã®ãã©ãŠãºã«ã©ã®ãããªæ¹æ³ãæäŸãããã§ããããïŒãããã®åé¡ã¯ã«ã¹ã¿ãã€ãºã§ããŸãïŒãã®ç¯ã§ã¯ã©ã®ããã«è¡ãããèšè¿°ããŸãã</Text>
 <Section name="thedesignview">
 <Title>
@@ -360,5 +361,5 @@
 <Text id="121">ãã­ã¥ã¡ã³ãã»ãã©ã°ã€ã³</Text>
 </Title>
-<!-- Missing translation: 122 -->
+<Text id="122">ãã®ç¯ã§ã¯ã³ã¬ã¯ã·ã§ã³ãäœ¿çšãããã­ã¥ã¡ã³ãã®ãã©ã°ã€ã³ãã©ã®ããã«æ§ç¯ãããã«ã€ããŠèšè¿°ããŸããã©ã®ãã©ã°ã€ã³ãäœ¿çšããããæ±ºããæ¹æ³ãšã©ã®ãã©ã¡ãŒã¿ãŒããã©ã°ã€ã³ã«æž¡ãããã©ã®é åºã§å®è¡ããããèª¬æããŸããããã¶ã€ã³ãã¿ãã®äžã®ãããã­ã¥ã¡ã³ãããã©ã°ã€ã³ããã¯ãªãã¯ããŠãã ããã</Text>
 <Text id="123">ãã©ã°ã€ã³ãè¿œå ããã«ã¯ãäžéšã«ãããè¿œå ãããã©ã°ã€ã³ãéžæããããã«ããŠã³ãªã¹ããäœ¿çšããŠéžæããŠãããããã©ã°ã€ã³ãè¿œå ããããã¯ãªãã¯ããŸãããé¢æ°ãèš­å®ããããŠã€ã³ããŠãè¡šç€ºãããåŸã§èšè¿°ãããŸããæ°èŠã®ãã©ã°ã€ã³ãèš­å®ãããšãããã©ã°ã€ã³ãå²ãåœãŠãããªã¹ãã®æçµã«è¿œå ãããŸããäžè¬çã«åãã©ã°ã€ã³ã¯äžã€ã®ã€ã³ã¹ã¿ã³ã¹ãããããŸããããããäžã€ä»¥äžã®ãã©ã°ã€ã³ãè¿œå ã§ããŸã;ãã®å Žåãçµæãæå¹ã«ããããã«ãè€æ°ã®ã€ã³ã¹ã¿ã³ã¹ãéåžžåå¥ã«èš­å®ãããŸãïŒããšãã° the process_expé¢æ°ã®ã»ãããªã©ã§ããhttp://wiki.greenstone.org/wiki/gsdoc/tutorial/en/enhanced_pdf.htm ãåç
 §ããŠãã ããïŒã </Text>
@@ -382,5 +383,5 @@
 <Text id="s1-3a">MG indexesã«ã€ããŠã¯ã<AutoText key="glidict::CDM.IndexManager.Level"/>ã¡ãã¥ãŒãäœ¿çšããŠã€ã³ããã¯ã¹ã®ãéžæããå¿
 èŠããããŸãã</Text>
-<Text id="si-4"> MGPP ãšã«ã·ãŒãã®ã€ã³ããã¯ã¹ã«ã€ããŠã¯ãã€ã³ããã¯ã¹ã®ç²ŸåºŠã¯ã€ã³ããã¯ã¹ããšã§ã¯ãªããå
+<Text id="si-4">MGPP ãšã«ã·ãŒãã®ã€ã³ããã¯ã¹ã«ã€ããŠã¯ãã€ã³ããã¯ã¹ã®ç²ŸåºŠã¯ã€ã³ããã¯ã¹ããšã§ã¯ãªããå
 æ¬çã«æ±ºå®ãããŸããå¯èœãªã¬ãã«ã¯ã¡ã€ã³ã®<AutoText key="glidict::CDM.GUI.Indexes"/>ç»é¢ã«è¡šç€ºããããã§ãã¯ããã¯ã¹ããã§ãã¯ããããšã§ã³ã¬ã¯ã·ã§ã³ã«è¿œå ãããŸãã<AutoText key="glidict::CDM.IndexManager.Add_Index"/> </Text>
 <Text id="si-5">ç¹å¥ãªã€ã³ããã¯ã¹ãMGPP ãšã«ã·ãŒãã§å©çšå¯èœã§ãïŒå
Index: /main/trunk/gli/help/ja/howtoavoidthisdocument.htm
===================================================================
--- /main/trunk/gli/help/ja/howtoavoidthisdocument.htm	(revision 24205)
+++ /main/trunk/gli/help/ja/howtoavoidthisdocument.htm	(revision 24206)
@@ -19,4 +19,5 @@
 <p>ç¹å®ã®ã³ã³ãã­ã¹ãã®ããã«ããã¢ã€ã³ã³ãã¯ãªãã¯ããé©åãªãã«ãã»ãã­ã¹ããäœæãããçåç¬Šãã€ããé©åãªãã«ãã»ããã£ã³ã°ãããŒã¯ããã</p>
 
+<p>å¶åŸ¡ã«ã€ããŠã¯ãããŠã¹ããã®äžã«çœ®ããšã©ã®ããã«å¶åŸ¡ããããªãããæç€ºãããããŒã«ãããããè¡šç€ºãããŸãã</p>
 
 <p>ã©ã€ãã©ãªã¢ã³ã»ã€ã³ã¿ãŒãã§ãŒã¹ãäœ¿çšããåã«ãæåã«ã°ãªãŒã³ã¹ãïŒã³ã®ãã­ã¥ã¡ã³ããŒã·ã§ã³ããèŠ§äžããã</p>
Index: /main/trunk/gli/help/ja/plugins.htm
===================================================================
--- /main/trunk/gli/help/ja/plugins.htm	(revision 24205)
+++ /main/trunk/gli/help/ja/plugins.htm	(revision 24206)
@@ -12,4 +12,5 @@
 
 
+<p>ãã®ç¯ã§ã¯ã³ã¬ã¯ã·ã§ã³ãäœ¿çšãããã­ã¥ã¡ã³ãã®ãã©ã°ã€ã³ãã©ã®ããã«æ§ç¯ãããã«ã€ããŠèšè¿°ããŸããã©ã®ãã©ã°ã€ã³ãäœ¿çšããããæ±ºããæ¹æ³ãšã©ã®ãã©ã¡ãŒã¿ãŒããã©ã°ã€ã³ã«æž¡ãããã©ã®é åºã§å®è¡ããããèª¬æããŸããããã¶ã€ã³ãã¿ãã®äžã®ãããã­ã¥ã¡ã³ãããã©ã°ã€ã³ããã¯ãªãã¯ããŠãã ããã</p>
 
 <p>ãã©ã°ã€ã³ãè¿œå ããã«ã¯ãäžéšã«ãããè¿œå ãããã©ã°ã€ã³ãéžæããããã«ããŠã³ãªã¹ããäœ¿çšããŠéžæããŠãããããã©ã°ã€ã³ãè¿œå ããããã¯ãªãã¯ããŸãããé¢æ°ãèš­å®ããããŠã€ã³ããŠãè¡šç€ºãããåŸã§èšè¿°ãããŸããæ°èŠã®ãã©ã°ã€ã³ãèš­å®ãããšãããã©ã°ã€ã³ãå²ãåœãŠãããªã¹ãã®æçµã«è¿œå ãããŸããäžè¬çã«åãã©ã°ã€ã³ã¯äžã€ã®ã€ã³ã¹ã¿ã³ã¹ãããããŸããããããäžã€ä»¥äžã®ãã©ã°ã€ã³ãè¿œå ã§ããŸã;ãã®å Žåãçµæãæå¹ã«ããããã«ãè€æ°ã®ã€ã³ã¹ã¿ã³ã¹ãéåžžåå¥ã«èš­å®ãããŸãïŒããšãã° the process_expé¢æ°ã®ã»ãããªã©ã§ããhttp://wiki.greenstone.org/wiki/gsdoc/tutorial/en/enhanced_pdf.htm ãåç
Index: /main/trunk/gli/help/ja/searchindexes.htm
===================================================================
--- /main/trunk/gli/help/ja/searchindexes.htm	(revision 24205)
+++ /main/trunk/gli/help/ja/searchindexes.htm	(revision 24206)
@@ -26,5 +26,5 @@
 èŠããããŸãã</p>
 
-<p> MGPP ãšã«ã·ãŒãã®ã€ã³ããã¯ã¹ã«ã€ããŠã¯ãã€ã³ããã¯ã¹ã®ç²ŸåºŠã¯ã€ã³ããã¯ã¹ããšã§ã¯ãªããå
+<p>MGPP ãšã«ã·ãŒãã®ã€ã³ããã¯ã¹ã«ã€ããŠã¯ãã€ã³ããã¯ã¹ã®ç²ŸåºŠã¯ã€ã³ããã¯ã¹ããšã§ã¯ãªããå
 æ¬çã«æ±ºå®ãããŸããå¯èœãªã¬ãã«ã¯ã¡ã€ã³ã®"çŽ¢åŒãæ€çŽ¢ãã  "ç»é¢ã«è¡šç€ºããããã§ãã¯ããã¯ã¹ããã§ãã¯ããããšã§ã³ã¬ã¯ã·ã§ã³ã«è¿œå ãããŸãã"çŽ¢åŒãè¿œå ãã  " </p>
 
Index: /main/trunk/gli/help/ja/theenrichview.htm
===================================================================
--- /main/trunk/gli/help/ja/theenrichview.htm	(revision 24205)
+++ /main/trunk/gli/help/ja/theenrichview.htm	(revision 24206)
@@ -19,5 +19,5 @@
 åãªã©ïŒãäžããŸãã</p>
 
-<p> "å
+<p>"å
 
 å®ããã  "ãã¥ãŒã®å·ŠåŽã«</p>