Index: /main/trunk/greenstone2/perllib/plugins/BasePlugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/BasePlugin.pm	(revision 24224)
+++ /main/trunk/greenstone2/perllib/plugins/BasePlugin.pm	(revision 24225)
@@ -1366,5 +1366,7 @@
     
     $doc_obj->associate_file($filename, $assocfilename, undef, $cursection);
+    # srclink_file is now deprecated because of the "_" in the metadataname. Use srclinkFile
     $doc_obj->add_utf8_metadata ($cursection, "srclink_file", $doc_obj->get_sourcefile());
+    $doc_obj->add_utf8_metadata ($cursection, "srclinkFile", $doc_obj->get_sourcefile());
 }
 
Index: /main/trunk/greenstone2/perllib/plugins/ConvertBinaryFile.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/ConvertBinaryFile.pm	(revision 24224)
+++ /main/trunk/greenstone2/perllib/plugins/ConvertBinaryFile.pm	(revision 24225)
@@ -476,6 +476,8 @@
 	$srclink_filename = $doc_obj->get_sourcefile();
     }
+    # srclink_file is now deprecated because of the "_" in the metadataname. Use srclinkFile
     $doc_obj->add_utf8_metadata ($cursection, "srcicon",  "_icon".$doc_ext."_"); 
     $doc_obj->add_utf8_metadata ($cursection, "srclink_file", $srclink_filename);
+    $doc_obj->add_utf8_metadata ($cursection, "srclinkFile", $srclink_filename);
     return 1;
 }
Index: /main/trunk/greenstone2/perllib/plugins/ConvertToRogPlugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/ConvertToRogPlugin.pm	(revision 24224)
+++ /main/trunk/greenstone2/perllib/plugins/ConvertToRogPlugin.pm	(revision 24225)
@@ -447,5 +447,7 @@
     $doc_obj->associate_file($filename, "doc.$doc_ext", undef, $cursection);
 
+    # srclink_file is now deprecated because of the "_" in the metadataname. Use srclinkFile
     $doc_obj->add_metadata ($cursection, "srclink_file", "doc.$doc_ext"); 
+    $doc_obj->add_metadata ($cursection, "srclinkFile", "doc.$doc_ext"); 
     $doc_obj->add_utf8_metadata ($cursection, "srcicon",  "_icon".$doc_ext."_"); 
 
Index: /main/trunk/greenstone2/perllib/plugins/ImageConverter.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/ImageConverter.pm	(revision 24224)
+++ /main/trunk/greenstone2/perllib/plugins/ImageConverter.pm	(revision 24225)
@@ -258,6 +258,8 @@
     }
 
+    # srclink_file is now deprecated because of the "_" in the metadataname. Use srclinkFile
     $doc_obj->add_metadata ($section, "srclink_file", $url_to_filename_no_path);
-    $doc_obj->add_metadata ($section, "srcicon", "<img src=\"_httpprefix_/collect/[collection]/index/assoc/$assocfilemeta/[srclink_file]\" width=\"[ImageWidth]\" height=\"[ImageHeight]\">");
+    $doc_obj->add_metadata ($section, "srclinkFile", $url_to_filename_no_path);
+    $doc_obj->add_metadata ($section, "srcicon", "<img src=\"_httpprefix_/collect/[collection]/index/assoc/$assocfilemeta/[srclinkFile]\" width=\"[ImageWidth]\" height=\"[ImageHeight]\">");
 
     # Add the image as an associated file
Index: /main/trunk/greenstone2/perllib/plugins/ImagePlugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/ImagePlugin.pm	(revision 24224)
+++ /main/trunk/greenstone2/perllib/plugins/ImagePlugin.pm	(revision 24225)
@@ -138,10 +138,12 @@
 		$doc_obj->associate_file($filename_full_path, $assoc_file, "", $section);
 		
+		# srclink_file is now deprecated because of the "_" in the metadataname. Use srclinkFile
 		$doc_obj->add_metadata ($section, "srclink_file", $doc_obj->get_sourcefile()); 
+		$doc_obj->add_metadata ($section, "srclinkFile", $doc_obj->get_sourcefile()); 
 		# We don't know the size of the image, but the browser should display it at full size
-		$doc_obj->add_metadata ($section, "srcicon", "<img src=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[srclink_file]\">");
+		$doc_obj->add_metadata ($section, "srcicon", "<img src=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[srclinkFile]\">");
 		
 		# Add a fake thumbnail icon with the full-sized image scaled down by the browser
-		$doc_obj->add_metadata ($section, "thumbicon", "<img src=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[srclink_file]\" width=\"" . $self->{'thumbnailsize'} . "\">");
+		$doc_obj->add_metadata ($section, "thumbicon", "<img src=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/[srclinkFile]\" width=\"" . $self->{'thumbnailsize'} . "\">");
     }
     #we have no text - adds dummy text and NoText metadata
Index: /main/trunk/greenstone2/perllib/plugins/MP3Plugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/MP3Plugin.pm	(revision 24224)
+++ /main/trunk/greenstone2/perllib/plugins/MP3Plugin.pm	(revision 24225)
@@ -267,5 +267,7 @@
     
     $doc_obj->add_metadata ($section, "srcicon", "_iconmp3_");
+    # srclink_file is now deprecated because of the "_" in the metadataname. Use srclinkFile
     $doc_obj->add_metadata ($section, "srclink_file", $assoc_url);
+    $doc_obj->add_metadata ($section, "srclinkFile", $assoc_url);
     my $applet_metadata = $self->{'applet_metadata'};
     if (defined $applet_metadata && $applet_metadata ) {
Index: /main/trunk/greenstone2/perllib/plugins/MediainfoOGVPlugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/MediainfoOGVPlugin.pm	(revision 24224)
+++ /main/trunk/greenstone2/perllib/plugins/MediainfoOGVPlugin.pm	(revision 24225)
@@ -145,5 +145,7 @@
     $doc_obj->add_utf8_metadata ($section, $assoc_field, $doc_obj->get_source()); # Source metadata is already in utf8
 
+    # srclink_file is now deprecated because of the "_" in the metadataname. Use srclinkFile
     $doc_obj->add_metadata ($section, "srclink_file", $doc_obj->get_sourcefile());
+    $doc_obj->add_metadata ($section, "srclinkFile", $doc_obj->get_sourcefile());
     $doc_obj->add_metadata ($section, "srcicon", "_iconogg_");
 
Index: /main/trunk/greenstone2/perllib/plugins/OggVorbisPlugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/OggVorbisPlugin.pm	(revision 24224)
+++ /main/trunk/greenstone2/perllib/plugins/OggVorbisPlugin.pm	(revision 24225)
@@ -137,5 +137,7 @@
 
     $doc_obj->add_metadata ($top_section, "FileFormat", "OggVorbis");
+    # srclink_file is now deprecated because of the "_" in the metadataname. Use srclinkFile
     $doc_obj->add_metadata ($top_section, "srclink_file", $doc_obj->get_sourcefile());
+    $doc_obj->add_metadata ($top_section, "srclinkFile", $doc_obj->get_sourcefile());
     $doc_obj->add_metadata ($top_section, "srcicon", "_iconogg_");
 
Index: /main/trunk/greenstone2/perllib/plugins/OpenDocumentPlugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/OpenDocumentPlugin.pm	(revision 24224)
+++ /main/trunk/greenstone2/perllib/plugins/OpenDocumentPlugin.pm	(revision 24225)
@@ -262,5 +262,7 @@
 
     #setup to doclink thingi
+    # srclink_file is now deprecated because of the "_" in the metadataname. Use srclinkFile
     $doc_obj->add_metadata ("", "srclink_file", $doc_obj->get_sourcefile());
+    $doc_obj->add_metadata ("", "srclinkFile", $doc_obj->get_sourcefile());
     $doc_obj->add_utf8_metadata ("", "srcicon",  "<img border=\"0\" align=\"absmiddle\" src=\"_httpprefix_/collect/[collection]/index/assoc/[assocfilepath]/thumbnail.png\" alt=\"View the Open document\" title=\"View the Open document\">"); 
 
Index: /main/trunk/greenstone2/perllib/plugins/RealMediaPlugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/RealMediaPlugin.pm	(revision 24224)
+++ /main/trunk/greenstone2/perllib/plugins/RealMediaPlugin.pm	(revision 24225)
@@ -108,5 +108,7 @@
     $doc_obj->add_metadata($top_section, "FileFormat", "RealMedia");
 
+    # srclink_file is now deprecated because of the "_" in the metadataname. Use srclinkFile
     $doc_obj->add_metadata ($top_section, "srclink_file", $doc_obj->get_sourcefile());
+    $doc_obj->add_metadata ($top_section, "srclinkFile", $doc_obj->get_sourcefile());
     $doc_obj->add_metadata($top_section, "srcicon", "_iconrmvideo_");
 
Index: /main/trunk/greenstone2/perllib/plugins/UnknownPlugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/UnknownPlugin.pm	(revision 24224)
+++ /main/trunk/greenstone2/perllib/plugins/UnknownPlugin.pm	(revision 24225)
@@ -145,5 +145,7 @@
     $doc_obj->add_metadata ($section, "MimeType", $mime_type);
     $doc_obj->add_utf8_metadata ($section, $assoc_field, $doc_obj->get_source()); # Source metadata is already in utf8 
+    # srclink_file is now deprecated because of the "_" in the metadataname. Use srclinkFile
     $doc_obj->add_metadata ($section, "srclink_file", $doc_obj->get_sourcefile());
+    $doc_obj->add_metadata ($section, "srclinkFile", $doc_obj->get_sourcefile());
     $doc_obj->add_metadata ($section, "srcicon", "_".$self->{'srcicon'}."_");
     